summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMatthias Schwarzott <zzam@gentoo.org>2008-12-10 22:29:09 +0000
committerMatthias Schwarzott <zzam@gentoo.org>2008-12-10 22:29:09 +0000
commit46d4cd5cd24b78c0de268acd01029aa20a11b5ec (patch)
tree1ed63ae1317c1227c3c8a531bcf115e665d55506 /sys-fs/udev/files
parentFix negation. (diff)
downloadgentoo-2-46d4cd5cd24b78c0de268acd01029aa20a11b5ec.tar.gz
gentoo-2-46d4cd5cd24b78c0de268acd01029aa20a11b5ec.tar.bz2
gentoo-2-46d4cd5cd24b78c0de268acd01029aa20a11b5ec.zip
Redesign of addons/init-scripts. Moved code into init-scripts and split into smaller parts. Source init-scripts from addons for older baselayouts.
(Portage version: 2.1.6/cvs/Linux 2.6.27-gentoo-r1 i686)
Diffstat (limited to 'sys-fs/udev/files')
-rw-r--r--sys-fs/udev/files/udev-135-r2.confd16
-rw-r--r--sys-fs/udev/files/udev-135-r2.initd196
-rwxr-xr-xsys-fs/udev/files/udev-dev-tarball-135-r2.initd91
-rwxr-xr-xsys-fs/udev/files/udev-mount-135-r2.initd101
-rw-r--r--sys-fs/udev/files/udev-start-135-r2.sh40
-rw-r--r--sys-fs/udev/files/udev-stop-135-r2.sh13
6 files changed, 457 insertions, 0 deletions
diff --git a/sys-fs/udev/files/udev-135-r2.confd b/sys-fs/udev/files/udev-135-r2.confd
new file mode 100644
index 000000000000..d26a4f67eed3
--- /dev/null
+++ b/sys-fs/udev/files/udev-135-r2.confd
@@ -0,0 +1,16 @@
+# /etc/conf.d/udev: config file for udev
+
+# We discourage to disable persistent-net!!
+# this may lead to random interface naming
+
+# Disable adding new rules for persistent-net
+persistent_net_disable="no"
+
+# Set to "yes" if you want to save /dev to a tarball on shutdown
+# and restore it on startup. This is useful if you have a lot of
+# custom device nodes that udev does not handle/know about.
+#
+# As this option is fragile, we recommend you
+# to create your devices in /lib/udev/devices.
+# These will be copied to /dev on boot.
+#rc_device_tarball="NO"
diff --git a/sys-fs/udev/files/udev-135-r2.initd b/sys-fs/udev/files/udev-135-r2.initd
new file mode 100644
index 000000000000..d0a14a06b7ac
--- /dev/null
+++ b/sys-fs/udev/files/udev-135-r2.initd
@@ -0,0 +1,196 @@
+#!/sbin/runscript
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+description="Run udevd and create the device-nodes"
+
+[ -e /etc/udev/udev.conf ] && . /etc/udev/udev.conf
+. /lib/udev/shell-compat.sh
+
+rc_coldplug=${rc_coldplug:-${RC_COLDPLUG:-YES}}
+
+depend()
+{
+ if [ -f /etc/init.d/sysfs ]; then
+ # require new enough openrc with sysinit being extra runlevel
+ # on linux we just check if sysfs init-script exists
+ # this is to silence out ugly warnings about not-existing sysfs script
+ provide dev
+ need sysfs udev-mount udev-dev-tarball
+ before checkfs fsck
+ fi
+}
+
+cleanup()
+{
+ # fail more gracely and not leave udevd running
+ start-stop-daemon --stop --exec /sbin/udevd
+ exit 1
+}
+
+disable_hotplug_agent()
+{
+ if [ -e /proc/sys/kernel/hotplug ]; then
+ echo "" >/proc/sys/kernel/hotplug
+ fi
+}
+
+root_link()
+{
+ /lib/udev/write_root_link_rule
+}
+
+persistent_net_switch()
+{
+ # this function disables rules files
+ # by creating new files with the same name
+ # in a temp rules directory with higher priority
+ local d=/dev/.udev/rules.d
+ if yesno "${persistent_net_disable:-no}"; then
+ mkdir -p "$d"
+ echo "# This file disables persistent-net due to /etc/conf.d/udev" \
+ > "$d"/75-persistent-net-generator.rules
+ fi
+}
+
+start_udevd()
+{
+ # load unix domain sockets if built as module, Bug #221253
+ if [ -e /proc/modules ] ; then
+ modprobe -q unix 2>/dev/null
+ fi
+ ebegin "Starting udevd"
+ start-stop-daemon --start --exec /sbin/udevd -- --daemon
+ eend $?
+}
+
+# populate /dev with devices already found by the kernel
+populate_dev()
+{
+ if get_bootparam "nocoldplug" ; then
+ rc_coldplug="NO"
+ ewarn "Skipping udev coldplug as requested in kernel cmdline"
+ fi
+
+ ebegin "Populating /dev with existing devices through uevents"
+ if yesno "${rc_coldplug}"; then
+ udevadm trigger
+ else
+ # Do not run any init-scripts, Bug #206518
+ udevadm control --env do_not_run_plug_service=1
+
+ # only create device nodes
+ udevadm trigger --attr-match=dev
+
+ # run persistent-net stuff, bug 191466
+ udevadm trigger --subsystem-match=net
+ fi
+ eend $?
+
+ ebegin "Waiting for uevents to be processed"
+ udevadm settle --timeout=60
+ eend $?
+
+ udevadm control --env do_not_run_plug_service=
+ return 0
+}
+
+display_hotplugged_services() {
+ local svcfile= svc= services=
+ for svcfile in "${RC_SVCDIR}"/hotplugged/*; do
+ svc="${svcfile##*/}"
+ [ -x "${svcfile}" ] || continue
+
+ # do not display this - better: do only inject it later :)
+ [ "$svc" = "udev-postmount" ] && continue
+
+ services="${services} ${svc}"
+ done
+ [ -n "${services}" ] && einfo "Device initiated services:${HILITE}${services}${NORMAL}"
+}
+
+inject_postmount_initd() {
+ if ! mark_service_hotplugged udev-postmount; then
+ IN_HOTPLUG=1 /etc/init.d/udev-postmount start >/dev/null 2>&1
+ fi
+ #einfo "Injected udev-postmount service"
+}
+
+check_persistent_net()
+{
+ # check if there are problems with persistent-net
+ local syspath= devs= problem=false
+ for syspath in /sys/class/net/*_rename*; do
+ if [ -d "${syspath}" ]; then
+ devs="${devs} ${syspath##*/}"
+ problem=true
+ fi
+ done
+
+ ${problem} || return 0
+
+ eerror "UDEV: Your system has a problem assigning persistent names"
+ eerror "to these network interfaces: ${devs}"
+
+ einfo "Checking persistent-net rules:"
+ # the sed-expression lists all duplicate lines
+ # from the input, like "uniq -d" does, but uniq
+ # is installed into /usr/bin and not available at boot.
+ dups=$(
+ RULES_FILE='/etc/udev/rules.d/70-persistent-net.rules'
+ . /lib/udev/rule_generator.functions
+ find_all_rules 'NAME=' '.*' | \
+ tr ' ' '\n' | \
+ sort | \
+ sed '$!N; s/^\(.*\)\n\1$/\1/; t; D'
+ )
+ if [ -n "${dups}" ]; then
+ ewarn "The rules create multiple entries assigning these names:"
+ eindent
+ ewarn "${dups}"
+ eoutdent
+ else
+ ewarn "Found no duplicate names in persistent-net rules,"
+ ewarn "there must be some other problem!"
+ fi
+ return 1
+}
+
+check_udev_works()
+{
+ # should exist on every system, else udev failed
+ if [ ! -e /dev/zero ]; then
+ eerror "Assuming udev failed somewhere, as /dev/zero does not exist."
+ return 1
+ fi
+ return 0
+}
+
+start()
+{
+ # do not run this on too old baselayout - udev-addon is already loaded!
+ if [ ! -e /lib/librc.so -a -f /etc/init.d/sysfs ]; then
+ eerror "The $SVCNAME init-script is written for baselayout-2!"
+ eerror "Please do not use it with baselayout-1!".
+ return 1
+ fi
+
+ root_link
+ persistent_net_switch
+
+ disable_hotplug_agent
+ start_udevd || cleanup
+ populate_dev || cleanup
+
+ check_persistent_net
+
+ check_udev_works || cleanup
+
+ if [ "$called_from_addon" != "1" ]; then
+ display_hotplugged_services
+ fi
+
+ inject_postmount_initd
+ return 0
+}
+
diff --git a/sys-fs/udev/files/udev-dev-tarball-135-r2.initd b/sys-fs/udev/files/udev-dev-tarball-135-r2.initd
new file mode 100755
index 000000000000..9e81ce534b35
--- /dev/null
+++ b/sys-fs/udev/files/udev-dev-tarball-135-r2.initd
@@ -0,0 +1,91 @@
+#!/sbin/runscript
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+description="Maintain a tarball of not udev managed device nodes"
+[ -e /etc/conf.d/udev ] && . /etc/conf.d/udev
+
+rc_device_tarball=${rc_device_tarball:-${RC_DEVICE_TARBALL:-NO}}
+device_tarball=/lib/udev/state/devices.tar.bz2
+
+depend() {
+ if [ -f /etc/init.d/sysfs ]; then
+ need udev-mount
+ fi
+}
+
+start()
+{
+ if yesno "${rc_device_tarball}" && \
+ [ -s "${device_tarball}" ]
+ then
+ ebegin "Populating /dev with saved device nodes"
+ tar -jxpf "${device_tarball}" -C /dev
+ eend $?
+ fi
+}
+
+stop() {
+ if [ -e /dev/.devfsd ] || [ ! -e /dev/.udev ] || [ ! -z "${CDBOOT}" ] || \
+ ! yesno "${rc_device_tarball}" || \
+ ! touch "${device_tarball}" 2>/dev/null
+ then
+ return 0
+ fi
+
+ ebegin "Saving device nodes"
+ # Handle our temp files
+ save_tmp_base=/tmp/udev.savedevices."$$"
+ devices_udev="${save_tmp_base}"/devices.udev
+ devices_real="${save_tmp_base}"/devices.real
+ devices_totar="${save_tmp_base}"/devices.totar
+ device_tmp_tarball="${save_tmp_base}"/devices
+
+ rm -rf "${save_tmp_base}"
+ mkdir "${save_tmp_base}"
+ touch "${devices_udev}" "${devices_real}" \
+ "${devices_totar}" "${device_tmp_tarball}"
+
+ if [ -f "${devices_udev}" -a -f "${devices_real}" -a \
+ -f "${devices_totar}" -a -f "${device_tmp_tarball}" ]
+ then
+ cd /dev
+ # Find all devices, but ignore .udev directory
+ find . -xdev -type b -or -type c -or -type l | \
+ cut -d/ -f2- | \
+ grep -v ^\\.udev >"${devices_real}"
+
+ # Figure out what udev created
+ udevadm info --export-db | sed -ne 's,^[SN]: \(.*\),\1,p' >"${devices_udev}"
+ # These ones we also do not want in there
+ for x in MAKEDEV core fd initctl pts shm stderr stdin stdout root; do
+ echo "${x}" >> "${devices_udev}"
+ done
+ if [ -d /lib/udev/devices ]; then
+ cd /lib/udev/devices
+ find . -xdev -type b -or -type c -or -type l | \
+ cut -d/ -f2- >> "${devices_udev}"
+ cd /dev
+ fi
+
+ fgrep -x -v -f "${devices_udev}" "${devices_real}" > "${devices_totar}"
+
+ # Now only tarball those not created by udev if we have any
+ if [ -s "${devices_totar}" ]; then
+ # we dont want to descend into mounted filesystems (e.g. devpts)
+ # looking up username may involve NIS/network
+ # and net may be down
+ tar --one-file-system --numeric-owner \
+ -jcpf "${device_tmp_tarball}" -T "${devices_totar}"
+ mv -f "${device_tmp_tarball}" "${device_tarball}"
+ else
+ rm -f "${device_tarball}"
+ fi
+ eend 0
+ else
+ eend 1 "Could not create temporary files!"
+ fi
+
+ rm -rf "${save_tmp_base}"
+}
+
diff --git a/sys-fs/udev/files/udev-mount-135-r2.initd b/sys-fs/udev/files/udev-mount-135-r2.initd
new file mode 100755
index 000000000000..f668417e0f14
--- /dev/null
+++ b/sys-fs/udev/files/udev-mount-135-r2.initd
@@ -0,0 +1,101 @@
+#!/sbin/runscript
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+description="Mount tmpfs on /dev"
+[ -e /etc/conf.d/udev ] && . /etc/conf.d/udev
+
+# get_KV and others
+. /lib/udev/shell-compat.sh
+
+# FIXME
+# Instead of this script testing kernel version, udev itself should
+# Maybe something like udevd --test || exit $?
+check_kernel()
+{
+ if [ $(get_KV) -lt $(KV_to_int '2.6.15') ]; then
+ eerror "Your kernel is too old to work with this version of udev."
+ eerror "Current udev only supports Linux kernel 2.6.15 and newer."
+ return 1
+ fi
+ if [ $(get_KV) -lt $(KV_to_int '2.6.18') ]; then
+ ewarn "You need at least Linux kernel 2.6.18 for reliable operation of udev."
+ fi
+ return 0
+}
+
+
+mount_dev_directory()
+{
+ # No options are processed here as they should all be in /etc/fstab
+ ebegin "Mounting /dev"
+ if fstabinfo --quiet /dev; then
+ mount -n /dev
+ else
+ # Some devices require exec, Bug #92921
+ mount -n -t tmpfs -o "exec,nosuid,mode=0755,size=10M" udev /dev
+ fi
+ eend $?
+}
+
+seed_dev()
+{
+ # Seed /dev with some things that we know we need
+
+ # creating /dev/console and /dev/tty1 to be able to write
+ # to $CONSOLE with/without bootsplash before udevd creates it
+ [ -c /dev/console ] || mknod /dev/console c 5 1
+ [ -c /dev/tty1 ] || mknod /dev/tty1 c 4 1
+
+ # udevd will dup its stdin/stdout/stderr to /dev/null
+ # and we do not want a file which gets buffered in ram
+ [ -c /dev/null ] || mknod /dev/null c 1 3
+
+ # copy over any persistant things
+ if [ -d /lib/udev/devices ]; then
+ cp -RPp /lib/udev/devices/* /dev 2>/dev/null
+ fi
+
+ # Not provided by sysfs but needed
+ ln -snf /proc/self/fd /dev/fd
+ ln -snf fd/0 /dev/stdin
+ ln -snf fd/1 /dev/stdout
+ ln -snf fd/2 /dev/stderr
+ [ -e /proc/kcore ] && ln -snf /proc/kcore /dev/core
+
+ # Create problematic directories
+ mkdir -p /dev/pts /dev/shm
+ return 0
+}
+
+
+start()
+{
+ # do not run this on too old baselayout - udev-addon is already loaded!
+ if [ ! -f /etc/init.d/sysfs ]; then
+ eerror "The $SVCNAME init-script is written for baselayout-2!"
+ eerror "Please do not use it with baselayout-1!".
+ return 1
+ fi
+
+ check_kernel || return 1
+ mount_dev_directory || return 1
+
+ # Selinux lovin; /selinux should be mounted by selinux-patched init
+ if [ -x /sbin/restorecon -a -c /selinux/null ]; then
+ restorecon /dev > /selinux/null
+ fi
+
+ # make sure it exists
+ mkdir -p /dev/.udev
+
+ # FIXME: Is this needed with openrc?
+ # Create a file so that our rc system knows it's still in sysinit.
+ # Existance means init scripts will not directly run.
+ # rc will remove the file when done with sysinit.
+ touch /dev/.rcsysinit
+
+ seed_dev
+
+ return 0
+}
diff --git a/sys-fs/udev/files/udev-start-135-r2.sh b/sys-fs/udev/files/udev-start-135-r2.sh
new file mode 100644
index 000000000000..e126fd8f12af
--- /dev/null
+++ b/sys-fs/udev/files/udev-start-135-r2.sh
@@ -0,0 +1,40 @@
+# Copyright 1999-2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+[ -e /etc/conf.d/udev ] && . /etc/conf.d/udev
+
+compat_volume_nodes()
+{
+ # Only do this for baselayout-1*
+ if [ ! -e /lib/librc.so ]; then
+
+ # Create nodes that udev can't
+ [ -x /sbin/lvm ] && \
+ /sbin/lvm vgscan -P --mknodes --ignorelockingfailure &>/dev/null
+ # Running evms_activate on a LiveCD causes lots of headaches
+ [ -z "${CDBOOT}" -a -x /sbin/evms_activate ] && \
+ /sbin/evms_activate -q &>/dev/null
+ fi
+}
+
+start_initd()
+{
+ (
+ called_from_addon=1
+ . /etc/init.d/"$1"
+ start
+ )
+}
+# mount tmpfs on /dev
+start_initd udev-mount || exit 1
+
+# load device tarball
+start_initd udev-dev-tarball
+
+# run udevd
+start_initd udev || exit 1
+
+compat_volume_nodes
+
+# udev started successfully
+exit 0
diff --git a/sys-fs/udev/files/udev-stop-135-r2.sh b/sys-fs/udev/files/udev-stop-135-r2.sh
new file mode 100644
index 000000000000..15e8d3db39eb
--- /dev/null
+++ b/sys-fs/udev/files/udev-stop-135-r2.sh
@@ -0,0 +1,13 @@
+# Copyright 1999-2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+# for function yesno
+. /lib/udev/shell-compat.sh
+
+# store device tarball
+(
+ . /etc/init.d/udev-dev-tarball
+ stop
+)
+
+exit 0